
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega16
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _rtc_status=R5
	.DEF _rx_wr_index=R4
	.DEF _rx_rd_index=R7
	.DEF _rx_counter=R6
	.DEF _tx_wr_index=R9
	.DEF _tx_rd_index=R8
	.DEF _tx_counter=R11
	.DEF _mSec=R12
	.DEF _State=R10

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer2_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  _usart_rx_isr
	JMP  0x00
	JMP  _usart_tx_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_tbl10_G102:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G102:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x2020003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x02
	.DW  __base_y_G101
	.DW  _0x2020003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;// I2C Bus functions
;#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=1
   .equ __scl_bit=0
; 0000 0009 #endasm
;#include <i2c.h>
;
;// PCF8583 Real Time Clock functions
;#include "PCF8583.h"
;unsigned char rtc_status;
;bit rtc_alarm;
;
;unsigned char rtc_read(unsigned char chip,unsigned char address)
; 0000 000D {

	.CSEG
_rtc_read:
;unsigned char a;
;a=(chip<<1)|0xa0;
	ST   -Y,R17
;	chip -> Y+2
;	address -> Y+1
;	a -> R17
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0xA0)
	MOV  R17,R30
;i2c_start();
	CALL _i2c_start
;i2c_write(a);
	ST   -Y,R17
	CALL SUBOPT_0x0
;i2c_write(address);
;i2c_start();
	CALL _i2c_start
;i2c_write(a|1);
	MOV  R30,R17
	ORI  R30,1
	ST   -Y,R30
	CALL _i2c_write
;a=i2c_read(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_read
	MOV  R17,R30
;i2c_stop();
	CALL _i2c_stop
;return a;
	MOV  R30,R17
	LDD  R17,Y+0
	RJMP _0x20A0005
;}
;
;void rtc_write(unsigned char chip, unsigned char address,unsigned char data)
;{
_rtc_write:
;i2c_start();
;	chip -> Y+2
;	address -> Y+1
;	data -> Y+0
	CALL _i2c_start
;i2c_write((chip<<1)|0xa0);
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0xA0)
	ST   -Y,R30
	CALL SUBOPT_0x0
;i2c_write(address);
;i2c_write(data);
	LD   R30,Y
	ST   -Y,R30
	CALL _i2c_write
;i2c_stop();
	CALL _i2c_stop
;}
	RJMP _0x20A0005
;
;unsigned char rtc_get_status(unsigned char chip)
;{
_rtc_get_status:
;rtc_status=rtc_read(chip,0);
;	chip -> Y+0
	CALL SUBOPT_0x1
	RCALL _rtc_read
	MOV  R5,R30
;rtc_alarm=(rtc_status&2);
	BST  R5,1
	BLD  R2,0
;return rtc_status;
	MOV  R30,R5
	JMP  _0x20A0001
;}
;
;void rtc_init(unsigned char chip,unsigned char dated_alarm)
;{
_rtc_init:
;unsigned char d;
;d=0x90;
	ST   -Y,R17
;	chip -> Y+2
;	dated_alarm -> Y+1
;	d -> R17
	LDI  R17,LOW(144)
;if (dated_alarm) d=0xb0;
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x3
	LDI  R17,LOW(176)
;rtc_status=0;
_0x3:
	CLR  R5
;rtc_alarm=0;
	CLT
	BLD  R2,0
;rtc_write(chip,0,0);
	LDD  R30,Y+2
	CALL SUBOPT_0x2
	RCALL _rtc_write
;rtc_write(chip,4,rtc_read(chip,4)&0x3f);
	LDD  R30,Y+2
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _rtc_read
	ANDI R30,LOW(0x3F)
	ST   -Y,R30
	RCALL _rtc_write
;rtc_write(chip,8,d);
	LDD  R30,Y+2
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	ST   -Y,R17
	RCALL _rtc_write
;}
	LDD  R17,Y+0
	RJMP _0x20A0005
;
;void rtc_stop(unsigned char chip)
;{
_rtc_stop:
;rtc_get_status(chip);
;	chip -> Y+0
	CALL SUBOPT_0x3
;rtc_status|=0x80;
	LDI  R30,LOW(128)
	OR   R5,R30
;rtc_write(chip,0,rtc_status);
	CALL SUBOPT_0x1
	ST   -Y,R5
	RCALL _rtc_write
;}
	JMP  _0x20A0001
;
;void rtc_start(unsigned char chip)
;{
_rtc_start:
;rtc_get_status(chip);
;	chip -> Y+0
	CALL SUBOPT_0x3
;rtc_status&=0x7f;
	LDI  R30,LOW(127)
	AND  R5,R30
;rtc_write(chip,0,rtc_status);
	CALL SUBOPT_0x1
	ST   -Y,R5
	RCALL _rtc_write
;}
	JMP  _0x20A0001
;
;void rtc_hold_off(unsigned char chip)
;{
_rtc_hold_off:
;rtc_get_status(chip);
;	chip -> Y+0
	CALL SUBOPT_0x3
;rtc_status&=0xbf;
	LDI  R30,LOW(191)
	AND  R5,R30
;rtc_write(chip,0,rtc_status);
	CALL SUBOPT_0x1
	ST   -Y,R5
	RCALL _rtc_write
;}
	JMP  _0x20A0001
;
;void rtc_hold_on(unsigned char chip)
;{
_rtc_hold_on:
;rtc_get_status(chip);
;	chip -> Y+0
	CALL SUBOPT_0x3
;rtc_status|=0x40;
	LDI  R30,LOW(64)
	OR   R5,R30
;rtc_write(chip,0,rtc_status);
	CALL SUBOPT_0x1
	ST   -Y,R5
	RCALL _rtc_write
;}
	JMP  _0x20A0001
;
;void rtc_alarm_off(unsigned char chip)
;{
;rtc_get_status(chip);
;	chip -> Y+0
;rtc_status&=0xfb;
;rtc_write(chip,0,rtc_status);
;}
;
;void rtc_alarm_on(unsigned char chip)
;{
;rtc_get_status(chip);
;	chip -> Y+0
;rtc_status|=4;
;rtc_write(chip,0,rtc_status);
;}
;
;unsigned char rtc_read_bcd(unsigned char chip,unsigned char addr)
;{
_rtc_read_bcd:
;return bcd2bin(rtc_read(chip,addr));
;	chip -> Y+1
;	addr -> Y+0
	CALL SUBOPT_0x4
	RCALL _rtc_read
	ST   -Y,R30
	RCALL _bcd2bin
	JMP  _0x20A0002
;}
;
;void rtc_write_bcd(unsigned char chip,unsigned char addr,unsigned char data)
;{
_rtc_write_bcd:
;rtc_write(chip,addr,bin2bcd(data));
;	chip -> Y+2
;	addr -> Y+1
;	data -> Y+0
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _bin2bcd
	ST   -Y,R30
	RCALL _rtc_write
;}
	RJMP _0x20A0005
;
;void rtc_write_word(unsigned char chip,unsigned char addr,unsigned data)
;{
;rtc_write(chip,addr,(unsigned char) data&0xff);
;	chip -> Y+3
;	addr -> Y+2
;	data -> Y+0
;rtc_write(chip,++addr,(unsigned char)(data>>8));
;}
;
;void rtc_write_date(unsigned char chip,unsigned char addr,unsigned char date,
;unsigned year)
;{
;rtc_write(chip,addr,bin2bcd(date)|(((unsigned char) year&3)<<6));
;	chip -> Y+4
;	addr -> Y+3
;	date -> Y+2
;	year -> Y+0
;}
;
;void rtc_get_time(unsigned char chip,unsigned char *hour,unsigned char *min,
;unsigned char *sec,unsigned char *hsec)
;{
_rtc_get_time:
;rtc_hold_on(chip);
;	chip -> Y+8
;	*hour -> Y+6
;	*min -> Y+4
;	*sec -> Y+2
;	*hsec -> Y+0
	LDD  R30,Y+8
	ST   -Y,R30
	RCALL _rtc_hold_on
;*hsec=rtc_read_bcd(chip,1);
	LDD  R30,Y+8
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _rtc_read_bcd
	LD   R26,Y
	LDD  R27,Y+1
	ST   X,R30
;*sec=rtc_read_bcd(chip,2);
	LDD  R30,Y+8
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _rtc_read_bcd
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
;*min=rtc_read_bcd(chip,3);
	LDD  R30,Y+8
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _rtc_read_bcd
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X,R30
;*hour=rtc_read_bcd(chip,4);
	LDD  R30,Y+8
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _rtc_read_bcd
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ST   X,R30
;rtc_hold_off(chip);
	LDD  R30,Y+8
	ST   -Y,R30
	RCALL _rtc_hold_off
;}
	ADIW R28,9
	RET
;
;void rtc_set_time(unsigned char chip,unsigned char hour,unsigned char min,
;unsigned char sec,unsigned char hsec)
;{
_rtc_set_time:
;rtc_stop(chip);
;	chip -> Y+4
;	hour -> Y+3
;	min -> Y+2
;	sec -> Y+1
;	hsec -> Y+0
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _rtc_stop
;rtc_write_bcd(chip,1,hsec);
	LDD  R30,Y+4
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDD  R30,Y+2
	CALL SUBOPT_0x5
;rtc_write_bcd(chip,2,sec);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDD  R30,Y+3
	CALL SUBOPT_0x5
;rtc_write_bcd(chip,3,min);
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDD  R30,Y+4
	CALL SUBOPT_0x5
;rtc_write_bcd(chip,4,hour);
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDD  R30,Y+5
	CALL SUBOPT_0x5
;rtc_start(chip);
	RCALL _rtc_start
;}
	ADIW R28,5
	RET
;
;void rtc_get_date(unsigned char chip,unsigned char *date,unsigned char *month,
;unsigned *year)
;{
;unsigned char dy;
;unsigned y1;
;rtc_hold_on(chip);
;	chip -> Y+10
;	*date -> Y+8
;	*month -> Y+6
;	*year -> Y+4
;	dy -> R17
;	y1 -> R18,R19
;dy=rtc_read(chip,5);
;*month=bcd2bin(rtc_read(chip,6)&0x1f);
;rtc_hold_off(chip);
;*date=bcd2bin(dy&0x3f);
;dy>>=6;
;y1=rtc_read(chip,0x10)|((unsigned) rtc_read(chip,0x11)<<8);
;if (((unsigned char) y1&3)!=dy) rtc_write_word(chip,0x10,++y1);
;*year=y1;
;}
;
;void rtc_set_date(unsigned char chip,unsigned char date,unsigned char month,
;unsigned year)
;{
;rtc_write_word(chip,0x10,year);
;	chip -> Y+4
;	date -> Y+3
;	month -> Y+2
;	year -> Y+0
;rtc_stop(chip);
;rtc_write_date(chip,5,date,year);
;rtc_write_bcd(chip,6,month);
;rtc_start(chip);
;}
;
;void rtc_get_alarm_time(unsigned char chip,unsigned char *hour,
;unsigned char *min,unsigned char *sec,unsigned char *hsec)
;{
;*hsec=rtc_read_bcd(chip,9);
;	chip -> Y+8
;	*hour -> Y+6
;	*min -> Y+4
;	*sec -> Y+2
;	*hsec -> Y+0
;*sec=rtc_read_bcd(chip,0xa);
;*min=rtc_read_bcd(chip,0xb);
;*hour=rtc_read_bcd(chip,0xc);
;}
;
;void rtc_set_alarm_time(unsigned char chip,unsigned char hour,
;unsigned char min,unsigned char sec,unsigned char hsec)
;{
;rtc_write_bcd(chip,9,hsec);
;	chip -> Y+4
;	hour -> Y+3
;	min -> Y+2
;	sec -> Y+1
;	hsec -> Y+0
;rtc_write_bcd(chip,0xa,sec);
;rtc_write_bcd(chip,0xb,min);
;rtc_write_bcd(chip,0xc,hour);
;}
;
;void rtc_get_alarm_date(unsigned char chip,unsigned char *date,
;unsigned char *month)
;{
;*date=bcd2bin(rtc_read(chip,0xd)&0x3f);
;	chip -> Y+4
;	*date -> Y+2
;	*month -> Y+0
;*month=bcd2bin(rtc_read(chip,0xe)&0x1f);
;}
;
;void rtc_set_alarm_date(unsigned char chip,unsigned char date,
;unsigned char month)
;{
;rtc_write_date(chip,0xd,date,0);
;	chip -> Y+2
;	date -> Y+1
;	month -> Y+0
;rtc_write_bcd(chip,0xe,month);
;}
;
;// Alphanumeric LCD Module functions
;#include <alcd.h>
;
;#ifndef RXB8
;#define RXB8 1
;#endif
;
;#ifndef TXB8
;#define TXB8 0
;#endif
;
;#ifndef UPE
;#define UPE 2
;#endif
;
;#ifndef DOR
;#define DOR 3
;#endif
;
;#ifndef FE
;#define FE 4
;#endif
;
;#ifndef UDRE
;#define UDRE 5
;#endif
;
;#ifndef RXC
;#define RXC 7
;#endif
;
;#define FRAMING_ERROR (1<<FE)
;#define PARITY_ERROR (1<<UPE)
;#define DATA_OVERRUN (1<<DOR)
;#define DATA_REGISTER_EMPTY (1<<UDRE)
;#define RX_COMPLETE (1<<RXC)
;
;// USART Receiver buffer
;#define RX_BUFFER_SIZE 8
;char rx_buffer[RX_BUFFER_SIZE];
;
;#if RX_BUFFER_SIZE <= 256
;unsigned char rx_wr_index,rx_rd_index,rx_counter;
;#else
;unsigned int rx_wr_index,rx_rd_index,rx_counter;
;#endif
;
;// This flag is set on USART Receiver buffer overflow
;bit rx_buffer_overflow;
;
;// USART Receiver interrupt service routine
;interrupt [USART_RXC] void usart_rx_isr(void)
; 0000 0043 {
_usart_rx_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0044 char status,data;
; 0000 0045 status=UCSRA;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
; 0000 0046 data=UDR;
	IN   R16,12
; 0000 0047 if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x5
; 0000 0048    {
; 0000 0049    rx_buffer[rx_wr_index++]=data;
	MOV  R30,R4
	INC  R4
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	ST   Z,R16
; 0000 004A #if RX_BUFFER_SIZE == 256
; 0000 004B    // special case for receiver buffer size=256
; 0000 004C    if (++rx_counter == 0)
; 0000 004D       {
; 0000 004E #else
; 0000 004F    if (rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
	LDI  R30,LOW(8)
	CP   R30,R4
	BRNE _0x6
	CLR  R4
; 0000 0050    if (++rx_counter == RX_BUFFER_SIZE)
_0x6:
	INC  R6
	LDI  R30,LOW(8)
	CP   R30,R6
	BRNE _0x7
; 0000 0051       {
; 0000 0052       rx_counter=0;
	CLR  R6
; 0000 0053 #endif
; 0000 0054       rx_buffer_overflow=1;
	SET
	BLD  R2,1
; 0000 0055       }
; 0000 0056    }
_0x7:
; 0000 0057 }
_0x5:
	LD   R16,Y+
	LD   R17,Y+
	RJMP _0x80
;
;#ifndef _DEBUG_TERMINAL_IO_
;// Get a character from the USART Receiver buffer
;#define _ALTERNATE_GETCHAR_
;#pragma used+
;char getchar(void)
; 0000 005E {
; 0000 005F char data;
; 0000 0060 while (rx_counter==0);
;	data -> R17
; 0000 0061 data=rx_buffer[rx_rd_index++];
; 0000 0062 #if RX_BUFFER_SIZE != 256
; 0000 0063 if (rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
; 0000 0064 #endif
; 0000 0065 #asm("cli")
; 0000 0066 --rx_counter;
; 0000 0067 #asm("sei")
; 0000 0068 return data;
; 0000 0069 }
;#pragma used-
;#endif
;
;// USART Transmitter buffer
;#define TX_BUFFER_SIZE 8
;char tx_buffer[TX_BUFFER_SIZE];
;
;#if TX_BUFFER_SIZE <= 256
;unsigned char tx_wr_index,tx_rd_index,tx_counter;
;#else
;unsigned int tx_wr_index,tx_rd_index,tx_counter;
;#endif
;
;// USART Transmitter interrupt service routine
;interrupt [USART_TXC] void usart_tx_isr(void)
; 0000 0079 {
_usart_tx_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 007A if (tx_counter)
	TST  R11
	BREQ _0xC
; 0000 007B    {
; 0000 007C    --tx_counter;
	DEC  R11
; 0000 007D    UDR=tx_buffer[tx_rd_index++];
	MOV  R30,R8
	INC  R8
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	LD   R30,Z
	OUT  0xC,R30
; 0000 007E #if TX_BUFFER_SIZE != 256
; 0000 007F    if (tx_rd_index == TX_BUFFER_SIZE) tx_rd_index=0;
	LDI  R30,LOW(8)
	CP   R30,R8
	BRNE _0xD
	CLR  R8
; 0000 0080 #endif
; 0000 0081    }
_0xD:
; 0000 0082 }
_0xC:
_0x80:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;#ifndef _DEBUG_TERMINAL_IO_
;// Write a character to the USART Transmitter buffer
;#define _ALTERNATE_PUTCHAR_
;#pragma used+
;void putchar(char c)
; 0000 0089 {
; 0000 008A while (tx_counter == TX_BUFFER_SIZE);
;	c -> Y+0
; 0000 008B #asm("cli")
; 0000 008C if (tx_counter || ((UCSRA & DATA_REGISTER_EMPTY)==0))
; 0000 008D    {
; 0000 008E    tx_buffer[tx_wr_index++]=c;
; 0000 008F #if TX_BUFFER_SIZE != 256
; 0000 0090    if (tx_wr_index == TX_BUFFER_SIZE) tx_wr_index=0;
; 0000 0091 #endif
; 0000 0092    ++tx_counter;
; 0000 0093    }
; 0000 0094 else
; 0000 0095    UDR=c;
; 0000 0096 #asm("sei")
; 0000 0097 }
;#pragma used-
;#endif
;
;// Standard Input/Output functions
;#include <stdio.h>
;
;#define RELAY1 PORTD.7
;#define RELAY2 PORTD.6
;#define MAXPARAMETERS 50
;#define LIGHTON 1
;#define LIGHTOFF 2
;
;#define ON 1
;#define OFF 0
;
;#define Cancel_BTN PINB.0
;#define Plus_BTN PINB.1
;#define Minus_BTN PINB.2
;#define Agree_BTN PINB.3
;
;unsigned int mSec, clock_mSec, Ring_mSec;
;char State, Button, Counter, i, LightFlag;
;char Hour, Minute, Seconds, Ring_Minute, mSeconds;
;
;eeprom unsigned char Parameters[MAXPARAMETERS][2] = {0};
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 00B4 {
_timer0_ovf_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00B5   TCNT0=0x83;
	LDI  R30,LOW(131)
	OUT  0x32,R30
; 0000 00B6   mSec++;
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
; 0000 00B7   clock_mSec++;
	LDI  R26,LOW(_clock_mSec)
	LDI  R27,HIGH(_clock_mSec)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 00B8 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;
;// Timer2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 00BC {
_timer2_ovf_isr:
	ST   -Y,R30
; 0000 00BD   TCNT2=0x83;
	LDI  R30,LOW(131)
	OUT  0x24,R30
; 0000 00BE 
; 0000 00BF }
	LD   R30,Y+
	RETI
;
;void lcd_putvalue(char Value, char X, char Y)
; 0000 00C2 {
_lcd_putvalue:
; 0000 00C3   lcd_gotoxy(X, Y);
;	Value -> Y+2
;	X -> Y+1
;	Y -> Y+0
	CALL SUBOPT_0x4
	CALL _lcd_gotoxy
; 0000 00C4   lcd_putchar(Value / 10 + 48);
	RJMP _0x20A0004
; 0000 00C5   Value %= 10;
; 0000 00C6   lcd_putchar(Value + 48);
; 0000 00C7   lcd_gotoxy(0, 0);
; 0000 00C8 }
;
;void lcd_putParameterIndex(char Value, char X, char Y)
; 0000 00CB {
_lcd_putParameterIndex:
; 0000 00CC   lcd_gotoxy(X, Y);
;	Value -> Y+2
;	X -> Y+1
;	Y -> Y+0
	CALL SUBOPT_0x4
	CALL _lcd_gotoxy
; 0000 00CD   lcd_putchar('P');
	LDI  R30,LOW(80)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 00CE   lcd_putchar(Value / 10 + 48);
_0x20A0004:
	LDD  R26,Y+2
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	SUBI R30,-LOW(48)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 00CF   Value %= 10;
	LDD  R26,Y+2
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	STD  Y+2,R30
; 0000 00D0   lcd_putchar(Value + 48);
	SUBI R30,-LOW(48)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 00D1   lcd_gotoxy(0, 0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 00D2 }
_0x20A0005:
	ADIW R28,3
	RET
;
;void lcd_putstring(unsigned char* string)
; 0000 00D5 {
; 0000 00D6   while (*string) lcd_putchar(*string++);
;	*string -> Y+0
; 0000 00D7 }
;
;void MemGuard(void)
; 0000 00DA {
_MemGuard:
; 0000 00DB   char i;
; 0000 00DC   for (i = 0; i < MAXPARAMETERS; i++)
	ST   -Y,R17
;	i -> R17
	LDI  R17,LOW(0)
_0x1A:
	CPI  R17,50
	BRSH _0x1B
; 0000 00DD   {
; 0000 00DE     if (Parameters[i][0] > 0xFE) Parameters[i][0] = 0;
	CALL SUBOPT_0x6
	CALL __EEPROMRDB
	CPI  R30,LOW(0xFF)
	BRLO _0x1C
	CALL SUBOPT_0x6
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
; 0000 00DF     if (Parameters[i][1] > 0xFE) Parameters[i][1] = 0;
_0x1C:
	CALL SUBOPT_0x7
	CALL __EEPROMRDB
	CPI  R30,LOW(0xFF)
	BRLO _0x1D
	CALL SUBOPT_0x7
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
; 0000 00E0   }
_0x1D:
	SUBI R17,-1
	RJMP _0x1A
_0x1B:
; 0000 00E1 }
	RJMP _0x20A0003
;
;char PressedButton(void)
; 0000 00E4 {
_PressedButton:
; 0000 00E5   char result = 0;
; 0000 00E6   if (Agree_BTN == 0) result = 'A';
	ST   -Y,R17
;	result -> R17
	LDI  R17,0
	SBIS 0x16,3
	LDI  R17,LOW(65)
; 0000 00E7   if (Plus_BTN == 0) result = '+';
	SBIS 0x16,1
	LDI  R17,LOW(43)
; 0000 00E8   if (Minus_BTN == 0) result = '-';
	SBIS 0x16,2
	LDI  R17,LOW(45)
; 0000 00E9   if (Cancel_BTN == 0) result = 'C';
	SBIS 0x16,0
	LDI  R17,LOW(67)
; 0000 00EA   return result;
	MOV  R30,R17
_0x20A0003:
	LD   R17,Y+
	RET
; 0000 00EB }
;
;void Light(char Value)
; 0000 00EE {
_Light:
; 0000 00EF   RELAY2 = Value;
;	Value -> Y+0
	LD   R30,Y
	CPI  R30,0
	BRNE _0x22
	CBI  0x12,6
	RJMP _0x23
_0x22:
	SBI  0x12,6
_0x23:
; 0000 00F0 }
	JMP  _0x20A0001
;
;void RingBell(char Value)
; 0000 00F3 {
_RingBell:
; 0000 00F4   RELAY1 = Value;
;	Value -> Y+0
	LD   R30,Y
	CPI  R30,0
	BRNE _0x24
	CBI  0x12,7
	RJMP _0x25
_0x24:
	SBI  0x12,7
_0x25:
; 0000 00F5 }
	JMP  _0x20A0001
;
;void main(void)
; 0000 00F8 {
_main:
; 0000 00F9 {
; 0000 00FA // Input/Output Ports initialization
; 0000 00FB // Port A initialization
; 0000 00FC // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 00FD // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 00FE PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 00FF DDRA=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1A,R30
; 0000 0100 
; 0000 0101 // Port B initialization
; 0000 0102 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
; 0000 0103 // State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=T State0=T
; 0000 0104 PORTB=0b00001111;
	LDI  R30,LOW(15)
	OUT  0x18,R30
; 0000 0105 DDRB=0xF0;
	LDI  R30,LOW(240)
	OUT  0x17,R30
; 0000 0106 
; 0000 0107 // Port C initialization
; 0000 0108 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=In
; 0000 0109 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=T State0=T
; 0000 010A PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 010B DDRC=0xFC;
	LDI  R30,LOW(252)
	OUT  0x14,R30
; 0000 010C 
; 0000 010D // Port D initialization
; 0000 010E // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=Out Func0=In
; 0000 010F // State7=0 State6=0 State5=0 State4=0 State3=T State2=0 State1=0 State0=T
; 0000 0110 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 0111 DDRD=0xF6;
	LDI  R30,LOW(246)
	OUT  0x11,R30
; 0000 0112 
; 0000 0113 // Timer/Counter 0 initialization
; 0000 0114 // Clock source: System Clock
; 0000 0115 // Clock value: 125,000 kHz
; 0000 0116 // Mode: Normal top=0xFF
; 0000 0117 // OC0 output: Disconnected
; 0000 0118 TCCR0=0x03;
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 0119 TCNT0=0x83;
	LDI  R30,LOW(131)
	OUT  0x32,R30
; 0000 011A OCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x3C,R30
; 0000 011B 
; 0000 011C // Timer/Counter 1 initialization
; 0000 011D // Clock source: System Clock
; 0000 011E // Clock value: Timer1 Stopped
; 0000 011F // Mode: Normal top=0xFFFF
; 0000 0120 // OC1A output: Discon.
; 0000 0121 // OC1B output: Discon.
; 0000 0122 // Noise Canceler: Off
; 0000 0123 // Input Capture on Falling Edge
; 0000 0124 // Timer1 Overflow Interrupt: Off
; 0000 0125 // Input Capture Interrupt: Off
; 0000 0126 // Compare A Match Interrupt: Off
; 0000 0127 // Compare B Match Interrupt: Off
; 0000 0128 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0129 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 012A TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 012B TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 012C ICR1H=0x00;
	OUT  0x27,R30
; 0000 012D ICR1L=0x00;
	OUT  0x26,R30
; 0000 012E OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 012F OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0130 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0131 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0132 
; 0000 0133 // Timer/Counter 2 initialization
; 0000 0134 // Clock source: System Clock
; 0000 0135 // Clock value: 125,000 kHz
; 0000 0136 // Mode: Normal top=0xFF
; 0000 0137 // OC2 output: Disconnected
; 0000 0138 ASSR=0x00;
	OUT  0x22,R30
; 0000 0139 TCCR2=0x04;
	LDI  R30,LOW(4)
	OUT  0x25,R30
; 0000 013A TCNT2=0x83;
	LDI  R30,LOW(131)
	OUT  0x24,R30
; 0000 013B OCR2=0x00;
	LDI  R30,LOW(0)
	OUT  0x23,R30
; 0000 013C 
; 0000 013D // External Interrupt(s) initialization
; 0000 013E // INT0: Off
; 0000 013F // INT1: Off
; 0000 0140 // INT2: Off
; 0000 0141 MCUCR=0x00;
	OUT  0x35,R30
; 0000 0142 MCUCSR=0x00;
	OUT  0x34,R30
; 0000 0143 
; 0000 0144 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0145 TIMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x39,R30
; 0000 0146 
; 0000 0147 // USART initialization
; 0000 0148 // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 0149 // USART Receiver: On
; 0000 014A // USART Transmitter: On
; 0000 014B // USART Mode: Asynchronous
; 0000 014C // USART Baud Rate: 9600
; 0000 014D UCSRA=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0000 014E UCSRB=0xD8;
	LDI  R30,LOW(216)
	OUT  0xA,R30
; 0000 014F UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 0150 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 0151 UBRRL=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
; 0000 0152 
; 0000 0153 // Analog Comparator initialization
; 0000 0154 // Analog Comparator: Off
; 0000 0155 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0156 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0157 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0158 
; 0000 0159 // ADC initialization
; 0000 015A // ADC disabled
; 0000 015B ADCSRA=0x00;
	OUT  0x6,R30
; 0000 015C 
; 0000 015D // SPI initialization
; 0000 015E // SPI disabled
; 0000 015F SPCR=0x00;
	OUT  0xD,R30
; 0000 0160 
; 0000 0161 // TWI initialization
; 0000 0162 // TWI disabled
; 0000 0163 TWCR=0x00;
	OUT  0x36,R30
; 0000 0164 
; 0000 0165 // I2C Bus initialization
; 0000 0166 i2c_init();
	CALL _i2c_init
; 0000 0167 
; 0000 0168 // PCF8583 Real Time Clock initialization
; 0000 0169 rtc_init(1,0);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _rtc_init
; 0000 016A 
; 0000 016B // Alphanumeric LCD initialization
; 0000 016C // Connections specified in the
; 0000 016D // Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
; 0000 016E // RS - PORTA Bit 0
; 0000 016F // RD - PORTA Bit 1
; 0000 0170 // EN - PORTA Bit 2
; 0000 0171 // D4 - PORTA Bit 4
; 0000 0172 // D5 - PORTA Bit 5
; 0000 0173 // D6 - PORTA Bit 6
; 0000 0174 // D7 - PORTA Bit 7
; 0000 0175 // Characters/line: 16
; 0000 0176 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
; 0000 0177 
; 0000 0178 // Global enable interrupts
; 0000 0179 #asm("sei")
	sei
; 0000 017A }
; 0000 017B MemGuard();
	RCALL _MemGuard
; 0000 017C lcd_clear();
	CALL _lcd_clear
; 0000 017D while (1)
_0x26:
; 0000 017E       {
; 0000 017F         Button = PressedButton();
	RCALL _PressedButton
	STS  _Button,R30
; 0000 0180         if (Button > 0) delay_ms(200);
	LDS  R26,_Button
	CPI  R26,LOW(0x1)
	BRLO _0x29
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	CALL SUBOPT_0x8
; 0000 0181         {
_0x29:
; 0000 0182         switch(State)
	MOV  R30,R10
	LDI  R31,0
; 0000 0183         {
; 0000 0184           case 0 : //   
	SBIW R30,0
	BRNE _0x2D
; 0000 0185             lcd_putParameterIndex(Counter, 1, 0);
	LDS  R30,_Counter
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _lcd_putParameterIndex
; 0000 0186             switch(Button)
	CALL SUBOPT_0x9
; 0000 0187             {
; 0000 0188               case '-' :
	BRNE _0x31
; 0000 0189                 if (Counter > 0) Counter--;
	LDS  R26,_Counter
	CPI  R26,LOW(0x1)
	BRLO _0x32
	LDS  R30,_Counter
	SUBI R30,LOW(1)
	STS  _Counter,R30
; 0000 018A                 if (Counter == 0) Counter = MAXPARAMETERS;
_0x32:
	LDS  R30,_Counter
	CPI  R30,0
	BRNE _0x33
	LDI  R30,LOW(50)
	STS  _Counter,R30
; 0000 018B               break;
_0x33:
	RJMP _0x30
; 0000 018C               case '+' :
_0x31:
	CPI  R30,LOW(0x2B)
	LDI  R26,HIGH(0x2B)
	CPC  R31,R26
	BRNE _0x34
; 0000 018D                 if (Counter < 1 + MAXPARAMETERS) Counter++;
	LDS  R26,_Counter
	CPI  R26,LOW(0x33)
	BRSH _0x35
	LDS  R30,_Counter
	SUBI R30,-LOW(1)
	STS  _Counter,R30
; 0000 018E                 if (Counter == 1 + MAXPARAMETERS) Counter = 0;
_0x35:
	LDS  R26,_Counter
	CPI  R26,LOW(0x33)
	BRNE _0x36
	LDI  R30,LOW(0)
	STS  _Counter,R30
; 0000 018F               break;
_0x36:
	RJMP _0x30
; 0000 0190               case 'A' : State = 1;
_0x34:
	CPI  R30,LOW(0x41)
	LDI  R26,HIGH(0x41)
	CPC  R31,R26
	BRNE _0x37
	LDI  R30,LOW(1)
	MOV  R10,R30
; 0000 0191               break;
; 0000 0192               case 'C' :
_0x37:
; 0000 0193               break;
; 0000 0194             }
_0x30:
; 0000 0195           break;
	RJMP _0x2C
; 0000 0196           case 1 : //    
_0x2D:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x39
; 0000 0197             if (Counter == 0) //  
	LDS  R30,_Counter
	CPI  R30,0
	BRNE _0x3A
; 0000 0198             {
; 0000 0199               lcd_putvalue(Hour, 5, 0);
	LDS  R30,_Hour
	CALL SUBOPT_0xA
; 0000 019A               switch(Button)
; 0000 019B               {
; 0000 019C                 case '-' : if (Hour > 0) Hour--; if (Hour == 0) Hour = 23;
	BRNE _0x3E
	LDS  R26,_Hour
	CPI  R26,LOW(0x1)
	BRLO _0x3F
	LDS  R30,_Hour
	SUBI R30,LOW(1)
	STS  _Hour,R30
_0x3F:
	LDS  R30,_Hour
	CPI  R30,0
	BRNE _0x40
	LDI  R30,LOW(23)
	STS  _Hour,R30
; 0000 019D                 break;
_0x40:
	RJMP _0x3D
; 0000 019E                 case '+' : if (Hour < 23) Hour++; if (Hour == 23) Hour = 0;
_0x3E:
	CPI  R30,LOW(0x2B)
	LDI  R26,HIGH(0x2B)
	CPC  R31,R26
	BRNE _0x41
	LDS  R26,_Hour
	CPI  R26,LOW(0x17)
	BRSH _0x42
	LDS  R30,_Hour
	SUBI R30,-LOW(1)
	STS  _Hour,R30
_0x42:
	LDS  R26,_Hour
	CPI  R26,LOW(0x17)
	BRNE _0x43
	LDI  R30,LOW(0)
	STS  _Hour,R30
; 0000 019F                 break;
_0x43:
	RJMP _0x3D
; 0000 01A0                 case 'A' : State = 2; rtc_set_time(1, Hour, Minute, 0, 0);
_0x41:
	CPI  R30,LOW(0x41)
	LDI  R26,HIGH(0x41)
	CPC  R31,R26
	BRNE _0x44
	LDI  R30,LOW(2)
	MOV  R10,R30
	CALL SUBOPT_0xB
	RCALL _rtc_set_time
; 0000 01A1                 break;
	RJMP _0x3D
; 0000 01A2                 case 'C' : State = 0; lcd_clear();
_0x44:
	CPI  R30,LOW(0x43)
	LDI  R26,HIGH(0x43)
	CPC  R31,R26
	BRNE _0x3D
	CLR  R10
	CALL _lcd_clear
; 0000 01A3                 break;
; 0000 01A4               }
_0x3D:
; 0000 01A5             }
; 0000 01A6             else
	RJMP _0x46
_0x3A:
; 0000 01A7             {
; 0000 01A8               lcd_putvalue(Parameters[Counter-1][0], 5, 0);
	CALL SUBOPT_0xC
	CALL SUBOPT_0xA
; 0000 01A9               switch(Button)
; 0000 01AA               {
; 0000 01AB                 case '-' :
	BRNE _0x4A
; 0000 01AC                   if (Parameters[Counter-1][0] > 0) Parameters[Counter-1][0]--;
	CALL SUBOPT_0xC
	CPI  R30,LOW(0x1)
	BRLO _0x4B
	CALL SUBOPT_0xC
	SUBI R30,LOW(1)
	CALL __EEPROMWRB
	SUBI R30,-LOW(1)
; 0000 01AD                   if (Parameters[Counter-1][0] == 0) Parameters[Counter-1][0] = 23;
_0x4B:
	CALL SUBOPT_0xC
	CPI  R30,0
	BRNE _0x4C
	CALL SUBOPT_0xD
	LDI  R30,LOW(23)
	CALL __EEPROMWRB
; 0000 01AE                 break;
_0x4C:
	RJMP _0x49
; 0000 01AF                 case '+' :
_0x4A:
	CPI  R30,LOW(0x2B)
	LDI  R26,HIGH(0x2B)
	CPC  R31,R26
	BRNE _0x4D
; 0000 01B0                   if (Parameters[Counter-1][0] < 23) Parameters[Counter-1][0]++;
	CALL SUBOPT_0xC
	CPI  R30,LOW(0x17)
	BRSH _0x4E
	CALL SUBOPT_0xC
	SUBI R30,-LOW(1)
	CALL __EEPROMWRB
	SUBI R30,LOW(1)
; 0000 01B1                   if (Parameters[Counter-1][0] == 23) Parameters[Counter-1][0] = 0;
_0x4E:
	CALL SUBOPT_0xC
	CPI  R30,LOW(0x17)
	BRNE _0x4F
	CALL SUBOPT_0xD
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
; 0000 01B2                 break;
_0x4F:
	RJMP _0x49
; 0000 01B3                 case 'A' : State = 2;
_0x4D:
	CPI  R30,LOW(0x41)
	LDI  R26,HIGH(0x41)
	CPC  R31,R26
	BRNE _0x50
	LDI  R30,LOW(2)
	MOV  R10,R30
; 0000 01B4                 break;
	RJMP _0x49
; 0000 01B5                 case 'C' : State = 0; lcd_clear();
_0x50:
	CPI  R30,LOW(0x43)
	LDI  R26,HIGH(0x43)
	CPC  R31,R26
	BRNE _0x49
	CLR  R10
	CALL _lcd_clear
; 0000 01B6                 break;
; 0000 01B7               }
_0x49:
; 0000 01B8             }
_0x46:
; 0000 01B9           break;
	RJMP _0x2C
; 0000 01BA           case 2 : //    
_0x39:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x2C
; 0000 01BB             if (Counter == 0) //  
	LDS  R30,_Counter
	CPI  R30,0
	BRNE _0x53
; 0000 01BC             {
; 0000 01BD               lcd_putvalue(Minute, 8, 0);
	LDS  R30,_Minute
	CALL SUBOPT_0xE
; 0000 01BE               switch(Button)
; 0000 01BF               {
; 0000 01C0                 case '-' : if (Minute > 0) Minute--; if (Minute == 0) Minute = 59;
	BRNE _0x57
	LDS  R26,_Minute
	CPI  R26,LOW(0x1)
	BRLO _0x58
	LDS  R30,_Minute
	SUBI R30,LOW(1)
	STS  _Minute,R30
_0x58:
	LDS  R30,_Minute
	CPI  R30,0
	BRNE _0x59
	LDI  R30,LOW(59)
	STS  _Minute,R30
; 0000 01C1                 break;
_0x59:
	RJMP _0x56
; 0000 01C2                 case '+' : if (Minute < 59) Minute++; if (Minute == 59) Minute = 0;
_0x57:
	CPI  R30,LOW(0x2B)
	LDI  R26,HIGH(0x2B)
	CPC  R31,R26
	BRNE _0x5A
	LDS  R26,_Minute
	CPI  R26,LOW(0x3B)
	BRSH _0x5B
	LDS  R30,_Minute
	SUBI R30,-LOW(1)
	STS  _Minute,R30
_0x5B:
	LDS  R26,_Minute
	CPI  R26,LOW(0x3B)
	BRNE _0x5C
	LDI  R30,LOW(0)
	STS  _Minute,R30
; 0000 01C3                 break;
_0x5C:
	RJMP _0x56
; 0000 01C4                 case 'A' : State = 0; rtc_set_time(1, Hour, Minute, 0, 0); lcd_clear();
_0x5A:
	CPI  R30,LOW(0x41)
	LDI  R26,HIGH(0x41)
	CPC  R31,R26
	BRNE _0x5D
	CLR  R10
	CALL SUBOPT_0xB
	RCALL _rtc_set_time
	CALL _lcd_clear
; 0000 01C5                 break;
	RJMP _0x56
; 0000 01C6                 case 'C' : State = 1;
_0x5D:
	CPI  R30,LOW(0x43)
	LDI  R26,HIGH(0x43)
	CPC  R31,R26
	BRNE _0x56
	LDI  R30,LOW(1)
	MOV  R10,R30
; 0000 01C7                 break;
; 0000 01C8               }
_0x56:
; 0000 01C9             }
; 0000 01CA             else
	RJMP _0x5F
_0x53:
; 0000 01CB             {
; 0000 01CC               lcd_putvalue(Parameters[Counter-1][1], 8, 0);
	CALL SUBOPT_0xF
	CALL SUBOPT_0xE
; 0000 01CD               switch(Button)
; 0000 01CE               {
; 0000 01CF                 case '-' :
	BRNE _0x63
; 0000 01D0                   if (Parameters[Counter-1][1] > 0) Parameters[Counter-1][1]--;
	CALL SUBOPT_0xF
	CPI  R30,LOW(0x1)
	BRLO _0x64
	CALL SUBOPT_0xF
	SUBI R30,LOW(1)
	CALL __EEPROMWRB
	SUBI R30,-LOW(1)
; 0000 01D1                   if (Parameters[Counter-1][1] == 0) Parameters[Counter-1][1] = 59;
_0x64:
	CALL SUBOPT_0xF
	CPI  R30,0
	BRNE _0x65
	CALL SUBOPT_0x10
	LDI  R30,LOW(59)
	CALL __EEPROMWRB
; 0000 01D2                 break;
_0x65:
	RJMP _0x62
; 0000 01D3                 case '+' :
_0x63:
	CPI  R30,LOW(0x2B)
	LDI  R26,HIGH(0x2B)
	CPC  R31,R26
	BRNE _0x66
; 0000 01D4                   if (Parameters[Counter-1][1] < 59) Parameters[Counter-1][1]++;
	CALL SUBOPT_0xF
	CPI  R30,LOW(0x3B)
	BRSH _0x67
	CALL SUBOPT_0xF
	SUBI R30,-LOW(1)
	CALL __EEPROMWRB
	SUBI R30,LOW(1)
; 0000 01D5                   if (Parameters[Counter-1][1] == 59) Parameters[Counter-1][1] = 0;
_0x67:
	CALL SUBOPT_0xF
	CPI  R30,LOW(0x3B)
	BRNE _0x68
	CALL SUBOPT_0x10
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
; 0000 01D6                 break;
_0x68:
	RJMP _0x62
; 0000 01D7                 case 'A' : State = 0; lcd_clear();
_0x66:
	CPI  R30,LOW(0x41)
	LDI  R26,HIGH(0x41)
	CPC  R31,R26
	BRNE _0x69
	CLR  R10
	CALL _lcd_clear
; 0000 01D8                 break;
	RJMP _0x62
; 0000 01D9                 case 'C' : State = 1;
_0x69:
	CPI  R30,LOW(0x43)
	LDI  R26,HIGH(0x43)
	CPC  R31,R26
	BRNE _0x62
	LDI  R30,LOW(1)
	MOV  R10,R30
; 0000 01DA                 break;
; 0000 01DB               }
_0x62:
; 0000 01DC             }
_0x5F:
; 0000 01DD           break;
; 0000 01DE         }
_0x2C:
; 0000 01DF         }
; 0000 01E0           if (mSec > 499)
	LDI  R30,LOW(499)
	LDI  R31,HIGH(499)
	CP   R30,R12
	CPC  R31,R13
	BRSH _0x6B
; 0000 01E1           {
; 0000 01E2             lcd_gotoxy(13, 1);
	CALL SUBOPT_0x11
; 0000 01E3             lcd_putchar(' ');
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 01E4           }
; 0000 01E5           if (mSec > 999)
_0x6B:
	LDI  R30,LOW(999)
	LDI  R31,HIGH(999)
	CP   R30,R12
	CPC  R31,R13
	BRSH _0x6C
; 0000 01E6           {
; 0000 01E7             if (State == 0) rtc_get_time(1, &Hour, &Minute, &Seconds, &mSeconds);
	TST  R10
	BRNE _0x6D
	CALL SUBOPT_0x12
; 0000 01E8             lcd_putvalue(Hour, 11, 1);
_0x6D:
	LDS  R30,_Hour
	ST   -Y,R30
	LDI  R30,LOW(11)
	CALL SUBOPT_0x13
; 0000 01E9             lcd_putvalue(Minute, 14, 1);
	LDS  R30,_Minute
	ST   -Y,R30
	LDI  R30,LOW(14)
	CALL SUBOPT_0x13
; 0000 01EA             mSec = 0;
	CLR  R12
	CLR  R13
; 0000 01EB             lcd_gotoxy(13, 1);
	CALL SUBOPT_0x11
; 0000 01EC             lcd_putchar(':');
	CALL SUBOPT_0x14
; 0000 01ED           }
; 0000 01EE 
; 0000 01EF         if (clock_mSec > 4999)
_0x6C:
	LDS  R26,_clock_mSec
	LDS  R27,_clock_mSec+1
	CPI  R26,LOW(0x1388)
	LDI  R30,HIGH(0x1388)
	CPC  R27,R30
	BRSH PC+3
	JMP _0x6E
; 0000 01F0         {
; 0000 01F1           clock_mSec = 0;
	LDI  R30,LOW(0)
	STS  _clock_mSec,R30
	STS  _clock_mSec+1,R30
; 0000 01F2           if (State == 0) rtc_get_time(1, &Hour, &Minute, &Seconds, &mSeconds);
	TST  R10
	BRNE _0x6F
	CALL SUBOPT_0x12
; 0000 01F3           if (Hour >= Parameters[LIGHTON][0])
_0x6F:
	CALL SUBOPT_0x15
	LDS  R26,_Hour
	CP   R26,R30
	BRSH PC+3
	JMP _0x70
; 0000 01F4           {
; 0000 01F5             if (Hour < Parameters[LIGHTOFF][0])
	CALL SUBOPT_0x16
	BRSH _0x71
; 0000 01F6             {
; 0000 01F7               if (Minute >= Parameters[LIGHTON][1])
	__POINTW2MN _Parameters,3
	CALL __EEPROMRDB
	LDS  R26,_Minute
	CP   R26,R30
	BRLO _0x72
; 0000 01F8               {
; 0000 01F9                 Light(ON);
	CALL SUBOPT_0x17
; 0000 01FA                 lcd_putvalue(Parameters[LIGHTON][0], 0, 1);
	CALL SUBOPT_0x18
; 0000 01FB                 lcd_gotoxy(2, 1);
	CALL SUBOPT_0x19
; 0000 01FC                 lcd_putchar(':');
; 0000 01FD                 lcd_putvalue(Parameters[LIGHTON][1], 3, 1);
	__POINTW2MN _Parameters,3
	CALL __EEPROMRDB
	ST   -Y,R30
	LDI  R30,LOW(3)
	CALL SUBOPT_0x13
; 0000 01FE               }
; 0000 01FF             }
_0x72:
; 0000 0200             if (Hour >= Parameters[LIGHTOFF][0])
_0x71:
	CALL SUBOPT_0x16
	BRLO _0x73
; 0000 0201             {
; 0000 0202               if (Minute >= Parameters[LIGHTOFF][1])
	__POINTW2MN _Parameters,5
	CALL __EEPROMRDB
	LDS  R26,_Minute
	CP   R26,R30
	BRLO _0x74
; 0000 0203               {
; 0000 0204                 Light(OFF);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _Light
; 0000 0205                 lcd_putvalue(Parameters[LIGHTOFF][0], 0, 1);
	__POINTW2MN _Parameters,4
	CALL __EEPROMRDB
	CALL SUBOPT_0x18
; 0000 0206                 lcd_gotoxy(2, 1);
	CALL SUBOPT_0x19
; 0000 0207                 lcd_putchar(':');
; 0000 0208                 lcd_putvalue(Parameters[LIGHTOFF][1], 3, 1);
	__POINTW2MN _Parameters,5
	RJMP _0x7E
; 0000 0209               }
; 0000 020A               else
_0x74:
; 0000 020B               {
; 0000 020C                 Light(ON);
	CALL SUBOPT_0x17
; 0000 020D                 lcd_putvalue(Parameters[LIGHTON][0], 0, 1);
	CALL SUBOPT_0x18
; 0000 020E                 lcd_gotoxy(2, 1);
	CALL SUBOPT_0x19
; 0000 020F                 lcd_putchar(':');
; 0000 0210                 lcd_putvalue(Parameters[LIGHTON][1], 3, 1);
	__POINTW2MN _Parameters,3
_0x7E:
	CALL __EEPROMRDB
	ST   -Y,R30
	LDI  R30,LOW(3)
	CALL SUBOPT_0x13
; 0000 0211               }
; 0000 0212             }
; 0000 0213           }
_0x73:
; 0000 0214           for(i = 3; i < MAXPARAMETERS; i++)
_0x70:
	LDI  R30,LOW(3)
	STS  _i,R30
_0x77:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x78
; 0000 0215           {
; 0000 0216             if (Parameters[i][0] == Hour) if (Parameters[i][1] == Minute) if (Seconds - 5 < Parameters[0][1]) RingBell(ON);
	CALL SUBOPT_0x1A
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	MOV  R26,R30
	LDS  R30,_Hour
	CP   R30,R26
	BRNE _0x79
	CALL SUBOPT_0x1A
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	CALL __EEPROMRDB
	MOV  R26,R30
	LDS  R30,_Minute
	CP   R30,R26
	BRNE _0x7A
	LDS  R30,_Seconds
	LDI  R31,0
	SBIW R30,5
	MOVW R0,R30
	__POINTW2MN _Parameters,1
	CALL __EEPROMRDB
	MOVW R26,R0
	LDI  R31,0
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x7B
	LDI  R30,LOW(1)
	RJMP _0x7F
; 0000 0217             else RingBell(OFF);
_0x7B:
	LDI  R30,LOW(0)
_0x7F:
	ST   -Y,R30
	RCALL _RingBell
; 0000 0218           }
_0x7A:
_0x79:
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RJMP _0x77
_0x78:
; 0000 0219         }
; 0000 021A 
; 0000 021B       }
_0x6E:
	RJMP _0x26
; 0000 021C }
_0x7D:
	RJMP _0x7D

	.CSEG
_bcd2bin:
    ld   r30,y
    swap r30
    andi r30,0xf
    mov  r26,r30
    lsl  r26
    lsl  r26
    add  r30,r26
    lsl  r30
    ld   r26,y+
    andi r26,0xf
    add  r30,r26
    ret
_bin2bcd:
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G101:
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2020004
	SBI  0x1B,4
	RJMP _0x2020005
_0x2020004:
	CBI  0x1B,4
_0x2020005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2020006
	SBI  0x1B,5
	RJMP _0x2020007
_0x2020006:
	CBI  0x1B,5
_0x2020007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2020008
	SBI  0x1B,6
	RJMP _0x2020009
_0x2020008:
	CBI  0x1B,6
_0x2020009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x202000A
	SBI  0x1B,7
	RJMP _0x202000B
_0x202000A:
	CBI  0x1B,7
_0x202000B:
	__DELAY_USB 5
	SBI  0x1B,2
	__DELAY_USB 13
	CBI  0x1B,2
	__DELAY_USB 13
	RJMP _0x20A0001
__lcd_write_data:
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G101
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G101
	__DELAY_USB 133
	RJMP _0x20A0001
_lcd_gotoxy:
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G101)
	SBCI R31,HIGH(-__base_y_G101)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	RCALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
_0x20A0002:
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R30,LOW(2)
	CALL SUBOPT_0x1B
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(1)
	CALL SUBOPT_0x1B
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2020011
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2020010
_0x2020011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	ST   -Y,R30
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x20A0001
_0x2020010:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	SBI  0x1B,0
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_data
	CBI  0x1B,0
	RJMP _0x20A0001
_lcd_init:
	SBI  0x1A,4
	SBI  0x1A,5
	SBI  0x1A,6
	SBI  0x1A,7
	SBI  0x1A,2
	SBI  0x1A,0
	SBI  0x1A,1
	CBI  0x1B,2
	CBI  0x1B,0
	CBI  0x1B,1
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G101,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G101,3
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CALL SUBOPT_0x8
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x1C
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_write_nibble_G101
	__DELAY_USW 200
	LDI  R30,LOW(40)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(133)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x20A0001:
	ADIW R28,1
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_rx_buffer:
	.BYTE 0x8
_tx_buffer:
	.BYTE 0x8
_clock_mSec:
	.BYTE 0x2
_Button:
	.BYTE 0x1
_Counter:
	.BYTE 0x1
_i:
	.BYTE 0x1
_Hour:
	.BYTE 0x1
_Minute:
	.BYTE 0x1
_Seconds:
	.BYTE 0x1
_mSeconds:
	.BYTE 0x1

	.ESEG
_Parameters:
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)

	.DSEG
__base_y_G101:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	CALL _i2c_write
	LDD  R30,Y+1
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	LD   R30,Y
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	LD   R30,Y
	ST   -Y,R30
	JMP  _rtc_get_status

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	LDD  R30,Y+1
	ST   -Y,R30
	LDD  R30,Y+1
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x5:
	ST   -Y,R30
	CALL _rtc_write_bcd
	LDD  R30,Y+4
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6:
	MOV  R30,R17
	LDI  R26,LOW(_Parameters)
	LDI  R27,HIGH(_Parameters)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x7:
	MOV  R30,R17
	LDI  R26,LOW(_Parameters)
	LDI  R27,HIGH(_Parameters)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x9:
	LDS  R30,_Button
	LDI  R31,0
	CPI  R30,LOW(0x2D)
	LDI  R26,HIGH(0x2D)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xA:
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_putvalue
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDS  R30,_Hour
	ST   -Y,R30
	LDS  R30,_Minute
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:69 WORDS
SUBOPT_0xC:
	LDS  R30,_Counter
	LDI  R31,0
	SBIW R30,1
	LDI  R26,LOW(_Parameters)
	LDI  R27,HIGH(_Parameters)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xD:
	LDS  R30,_Counter
	LDI  R31,0
	SBIW R30,1
	LDI  R26,LOW(_Parameters)
	LDI  R27,HIGH(_Parameters)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xE:
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_putvalue
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:75 WORDS
SUBOPT_0xF:
	LDS  R30,_Counter
	LDI  R31,0
	SBIW R30,1
	LDI  R26,LOW(_Parameters)
	LDI  R27,HIGH(_Parameters)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x10:
	LDS  R30,_Counter
	LDI  R31,0
	SBIW R30,1
	LDI  R26,LOW(_Parameters)
	LDI  R27,HIGH(_Parameters)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(_Hour)
	LDI  R31,HIGH(_Hour)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Minute)
	LDI  R31,HIGH(_Minute)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Seconds)
	LDI  R31,HIGH(_Seconds)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_mSeconds)
	LDI  R31,HIGH(_mSeconds)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _rtc_get_time

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x13:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_putvalue

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(58)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	__POINTW2MN _Parameters,2
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x16:
	__POINTW2MN _Parameters,4
	CALL __EEPROMRDB
	LDS  R26,_Hour
	CP   R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _Light
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1A:
	LDS  R30,_i
	LDI  R26,LOW(_Parameters)
	LDI  R27,HIGH(_Parameters)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1B:
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1C:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL __lcd_write_nibble_G101
	__DELAY_USW 200
	RET


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	rjmp __i2c_delay1

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
